/*
======================================================================
Use this script to reset your rest length.
If you have acidently ajusted them
    or you have moved bones and need to fix them.

Will not work on bones with no child bones.

www.Steelronin.com
Scott@steelronin.com
======================================================================
*/

scriptName = "Reset Rest v0.1.1";
copyright = "Copyright (c) 2003 Scott lange";



@version 2.2
@warnings
@name SR_Reset_Rest
@script generic


generic
{
    c1 = 1;
    sList = Scene().getSelect();

    // reverse slist order
    listcopy = sList;
    for(a=1;a<=size(listcopy);a++)
    	sList[(size(listcopy)+1) - a]=listcopy[a];
    
    obj = sList[1];
    objc = obj.firstChild();
    if(obj.genus < 4)
    {
        error("ERROR!!! Must have some bone selected!");
        return;
    }
    if(objc == nil)
    {
        warn("Bone Rest length canot be reset!");
    }
    reqbegin(scriptName);

    c1 = ctlchoice("",c1,@"RestPosition","Position"@);
        ctlposition(c1,15,5,200,30);
    if(!reqpost()) return;   
    c1 = getvalue(c1);
    reqend();
    
    t = Scene().currenttime;
    n = size(sList);
    i;
    for(i = 1;i <= n;i++){
        obj = sList[i];
        objc = obj.firstChild();
        objr = obj.restlength;
        if(c1 == 1)
        {
            if(objc == nil){}
            else
                childrest = objc.restParam(POSITION);
        }
        else
        {
            if(objc == nil){}
            else
                childrest = objc.getPosition(t);
        }    
        SelectItem(obj.id);
        
        //Reset ResL;
        if(obj.genus == 4)      //BONE
        {
            if(objc == nil){}
            else
            BoneRestLength(childrest.z);
        }
        else
            error("ERROR!!! Must have some bone selected!");
        
    }
SelectItem(sList[1].id);
for(n=2;n<=size(sList);n++)
AddToSelection(sList[n].id);
}
